/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20161210-64(RM)
 * Copyright (c) 2000 - 2016 Intel Corporation
 * 
 * Disassembling to non-symbolic legacy ASL operators
 *
 * Disassembly of SSDT-9.aml, Fri Dec 29 13:16:02 2017
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000B64 (2916)
 *     Revision         0x02
 *     Checksum         0x30
 *     OEM ID           "XMCC"
 *     OEM Table ID     "XMCC1701"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "ACPI"
 *     Compiler Version 0x00040000 (262144)
 */
DefinitionBlock ("", "SSDT", 2, "XMCC", "XMCC1701", 0x00001000)
{
    External (_SB_.PCI0.LPCB.CCI0, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.CCI1, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.CCI2, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.CCI3, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.CTL0, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.CTL1, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.CTL2, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.CTL3, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.CTL4, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.CTL5, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.CTL6, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.CTL7, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.EC2A, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGI0, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGI1, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGI2, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGI3, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGI4, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGI5, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGI6, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGI7, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGI8, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGI9, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGIA, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGIB, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGIC, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGID, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGIE, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGIF, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGO0, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGO1, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGO2, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGO3, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGO4, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGO5, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGO6, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGO7, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGO8, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGO9, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGOA, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGOB, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGOC, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGOD, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGOE, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.MGOF, IntObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.OCPF, FieldUnitObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.OCPT, FieldUnitObj)    // (from opcode)
    External (_SB_.PCI0.XHC_.RHUB, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.XHC_.RHUB.TPLD, MethodObj)    // 2 Arguments (from opcode)
    External (P8XH, MethodObj)    // 2 Arguments (from opcode)
    External (UBCB, UnknownObj)    // (from opcode)
    External (USTC, UnknownObj)    // (from opcode)
    External (XDCE, UnknownObj)    // (from opcode)

    Scope (\_SB)
    {
        Device (UBTC)
        {
            Name (_HID, EisaId ("USBC000"))  // _HID: Hardware ID
            Name (_CID, EisaId ("PNP0CA0"))  // _CID: Compatible ID
            Name (_UID, Zero)  // _UID: Unique ID
            Name (_DDN, "USB Type C")  // _DDN: DOS Device Name
            Name (_ADR, Zero)  // _ADR: Address
            Name (CRS, ResourceTemplate ()
            {
                Memory32Fixed (ReadWrite,
                    0x00000000,         // Address Base
                    0x00001000,         // Address Length
                    _Y2C)
            })
            Device (CR01)
            {
                Name (_ADR, Zero)  // _ADR: Address
                Method (_PLD, 0, NotSerialized)  // _PLD: Physical Location of Device
                {
                    If (LEqual (USTC, One))
                    {
                        Return (\_SB.PCI0.XHC.RHUB.TPLD (One, One))
                    }
                }

                Name (UPC3, Package (0x04)
                {
                    0xFF, 
                    0x0A, 
                    Zero, 
                    Zero
                })
                Method (_UPC, 0, Serialized)  // _UPC: USB Port Capabilities
                {
                    Return (UPC3)
                }
            }

            Method (_CRS, 0, Serialized)  // _CRS: Current Resource Settings
            {
                CreateDWordField (CRS, \_SB.UBTC._Y2C._BAS, CBAS)  // _BAS: Base Address
                Store (UBCB, CBAS)
                Return (CRS)
            }

            Method (_STA, 0, NotSerialized)  // _STA: Status
            {
                Store (0x05, \_SB.PCI0.LPCB.OCPT)
                If (LEqual (And (\_SB.PCI0.LPCB.OCPF, One), One))
                {
                    Return (Zero)
                }

                Return (0x0F)
            }

            OperationRegion (USBC, SystemMemory, UBCB, 0x38)
            Field (USBC, ByteAcc, Lock, Preserve)
            {
                VER1,   8, 
                VER2,   8, 
                RSV1,   8, 
                RSV2,   8, 
                CCI0,   8, 
                CCI1,   8, 
                CCI2,   8, 
                CCI3,   8, 
                CTL0,   8, 
                CTL1,   8, 
                CTL2,   8, 
                CTL3,   8, 
                CTL4,   8, 
                CTL5,   8, 
                CTL6,   8, 
                CTL7,   8, 
                MGI0,   8, 
                MGI1,   8, 
                MGI2,   8, 
                MGI3,   8, 
                MGI4,   8, 
                MGI5,   8, 
                MGI6,   8, 
                MGI7,   8, 
                MGI8,   8, 
                MGI9,   8, 
                MGIA,   8, 
                MGIB,   8, 
                MGIC,   8, 
                MGID,   8, 
                MGIE,   8, 
                MGIF,   8, 
                MGO0,   8, 
                MGO1,   8, 
                MGO2,   8, 
                MGO3,   8, 
                MGO4,   8, 
                MGO5,   8, 
                MGO6,   8, 
                MGO7,   8, 
                MGO8,   8, 
                MGO9,   8, 
                MGOA,   8, 
                MGOB,   8, 
                MGOC,   8, 
                MGOD,   8, 
                MGOE,   8, 
                MGOF,   8
            }

            OperationRegion (PSMI, SystemIO, 0xB2, 0x02)
            Field (PSMI, ByteAcc, NoLock, Preserve)
            {
                APMC,   8
            }

            Method (OSMI, 1, NotSerialized)
            {
                Store (0xBE, APMC)
                Stall (0xFF)
                Stall (0xFF)
                Stall (0xFF)
                Stall (0xFF)
                Stall (0xFF)
                Stall (0xFF)
            }

            Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
            {
                Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
                If (LEqual (Arg0, ToUUID ("6f8398c2-7ca4-11e4-ad36-631042b5008f")))
                {
                    While (One)
                    {
                        Store (ToInteger (Arg2), _T_0)
                        If (LEqual (_T_0, Zero))
                        {
                            Return (Buffer (One)
                            {
                                 0x0F                                           
                            })
                        }
                        ElseIf (LEqual (_T_0, One))
                        {
                            Store (MGO0, \_SB.PCI0.LPCB.MGO0)
                            Store (MGO1, \_SB.PCI0.LPCB.MGO1)
                            Store (MGO2, \_SB.PCI0.LPCB.MGO2)
                            Store (MGO3, \_SB.PCI0.LPCB.MGO3)
                            Store (MGO4, \_SB.PCI0.LPCB.MGO4)
                            Store (MGO5, \_SB.PCI0.LPCB.MGO5)
                            Store (MGO6, \_SB.PCI0.LPCB.MGO6)
                            Store (MGO7, \_SB.PCI0.LPCB.MGO7)
                            Store (MGO8, \_SB.PCI0.LPCB.MGO8)
                            Store (MGO9, \_SB.PCI0.LPCB.MGO9)
                            Store (MGOA, \_SB.PCI0.LPCB.MGOA)
                            Store (MGOB, \_SB.PCI0.LPCB.MGOB)
                            Store (MGOC, \_SB.PCI0.LPCB.MGOC)
                            Store (MGOD, \_SB.PCI0.LPCB.MGOD)
                            Store (MGOE, \_SB.PCI0.LPCB.MGOE)
                            Store (MGOF, \_SB.PCI0.LPCB.MGOF)
                            Store (CTL0, \_SB.PCI0.LPCB.CTL0)
                            Store (CTL1, \_SB.PCI0.LPCB.CTL1)
                            Store (CTL2, \_SB.PCI0.LPCB.CTL2)
                            Store (CTL3, \_SB.PCI0.LPCB.CTL3)
                            Store (CTL4, \_SB.PCI0.LPCB.CTL4)
                            Store (CTL5, \_SB.PCI0.LPCB.CTL5)
                            Store (CTL6, \_SB.PCI0.LPCB.CTL6)
                            Store (CTL7, \_SB.PCI0.LPCB.CTL7)
                            OSMI (0xE0)
                            P8XH (Zero, 0xE0)
                        }
                        ElseIf (LEqual (_T_0, 0x02))
                        {
                            Store (\_SB.PCI0.LPCB.MGI0, MGI0)
                            Store (\_SB.PCI0.LPCB.MGI1, MGI1)
                            Store (\_SB.PCI0.LPCB.MGI2, MGI2)
                            Store (\_SB.PCI0.LPCB.MGI3, MGI3)
                            Store (\_SB.PCI0.LPCB.MGI4, MGI4)
                            Store (\_SB.PCI0.LPCB.MGI5, MGI5)
                            Store (\_SB.PCI0.LPCB.MGI6, MGI6)
                            Store (\_SB.PCI0.LPCB.MGI7, MGI7)
                            Store (\_SB.PCI0.LPCB.MGI8, MGI8)
                            Store (\_SB.PCI0.LPCB.MGI9, MGI9)
                            Store (\_SB.PCI0.LPCB.MGIA, MGIA)
                            Store (\_SB.PCI0.LPCB.MGIB, MGIB)
                            Store (\_SB.PCI0.LPCB.MGIC, MGIC)
                            Store (\_SB.PCI0.LPCB.MGID, MGID)
                            Store (\_SB.PCI0.LPCB.MGIE, MGIE)
                            Store (\_SB.PCI0.LPCB.MGIF, MGIF)
                            Store (\_SB.PCI0.LPCB.CCI0, CCI0)
                            Store (\_SB.PCI0.LPCB.CCI1, CCI1)
                            Store (\_SB.PCI0.LPCB.CCI2, CCI2)
                            Store (\_SB.PCI0.LPCB.CCI3, CCI3)
                        }
                        ElseIf (LEqual (_T_0, 0x03))
                        {
                            Return (XDCE)
                        }

                        Break
                    }
                }

                Return (Buffer (One)
                {
                     0x00                                           
                })
            }
        }
    }
}

